%ext ck5
%version 1.4
# Load the modified graphics
%egagraph EGAGRAPH.ck5
%egahead EGAHEAD.ck5
%maphead maphead.ck5
%patchfile $1FDE0 "STORY.CK5"
%patchfile $20cd7 ck5load.bin 	
%patchfile $25B22 Keen13.tli
%patchfile $21C80 AUDIOHED.CK5	#Audio header
%patchfile $35EC4 AUDIODCT.CK5	#Audio dictionary

# disable the EGAGRAPH.CK5 merging code entirely
# -> frees up $30425-$304BD (153 bytes) for dseg variables
# -> frees up $3CC1-$3E74 (436 bytes) for code or far strings

%patch $3E78
	$90 $90 $90 $90

#################
# Levels                      #
#################


#Allow 24 levels in Keen 5 v1.4:
#First increase the number of levels we can access from the map to maximum (+6)
%patch $D2C2 $18 #Number of levels enterable ($18 = 24)
%patch $8C20 $18 #Number of level song entries (24, see below)

#This is the music played in each level:
#            
#192 = 0 
#193 = 1 
#194 = 2 
#195 = 3 
#196 = 4 
#197 = 5 
#198 = 6 
#199 = 7 
#200 = 8 
#201 = 9 
#202 = A 
#203 = B 
#204 = C 
#205 = D 


#             VALUE   LEVEL                      MUSIC PLAYED            LEVEL No
%patch $3067A $000BW  #Map                       (Omegamatic)              0
              $0000W  #Ion Ventilation System    (Wednesday on the Beach)  1
              $0002W  #Security Center           (Security Center)         2
              $0002W  #Defense Tunnel Vlook      (Be Sphereful)            3
              $0003W  #Energy Flow Systems       (Make it Tighter)         4
              $0002W  #Defense Tunnel Burrh      (Be Sphereful)            5
              $0003W  #Regulation Control Center (Make it Tighter)         6
              $0002W  #Defense Tunnel Sorra      (Be Sphereful)            7
              $0003W  #Neutrino Burst Injector   (Make it Tighter)         8
              $0003W  #Defense Tunnel Teln       (Be Sphereful)            9
              $0003W  #Brownian Motion Inducer   (Make it Tighter)         10
              $0002W  #Gravitational Damping Hub (Be Sphereful)                11
              $0005W  #Quantum Explosion Dynamo  (QED)                     12
              $0001W  #Korath III Base          (Security Center)                13
              $0003W  #Ending\Level 14           (Make it Tighter)                 14
              $0001W  #High Scores               (High Scores)             15
%patch $3069C $0002W #Protection Gallery 1             (Be Sphereful)		  16
              $0002W #Protection Gallery 2             (Be Sphereful)			  17 --------
              $0002W #Protection Gallery 3             (Be Sphereful)  	  18
              $0002W  #Protection Gallery 4            (Be Sphereful)                19 --------
              $0002W  #Dynamo Corridor            (Make it Tighter)               20
              $0003W  #Fuse 1                  (Make it Tighter)                 21
              $0003W  #Fuse 2               (Be Sphereful)            22
              $0002W  #Extra 2               (Be Sphereful)             23
              $0002W  #End Sequence (NO LEVEL!) (Be Sphereful)             N/A
              $0002W  #Help menu (NO LEVEL!)    (Be Sphereful)             N/A
              $0002W  #Game Over (NO LEVEL!)    (Be Sphereful)                   N/A
              $0002W  #Story (NO LEVEL!)        (Be Sphereful)                   N/A


#Level name pointers:
%patch $31AB4 $20040000RL #Map
              $20050000RL #Level 1
              $20070000RL #Level 2
              $20080000RL #Level 3
              $200A0000RL #Level 4
              $200C0000RL #Level 5
              $200E0000RL #Level 6
              $20100000RL #Level 7
              $20120000RL #Level 8
              $3034065ERL  #Level 9
              $20160000RL #Level 10
              $20180000RL #Level 11
              $201A0000RL #Level 12
              $201C0000RL #Level 13
              $3034065ERL  #Level 14
              $201E0000RL #High Scores
              $201D0000RL #Defense Tunnel 1 (#16)
              $201D0000RL #Defense Tunnel 2 (#17)
              $201D0000RL #Defense Tunnel 3 (#18)
              $201D0000RL #Defense Tunnel 4 (#19)
              $20180000RL #Dynamo Corridor (#20)
              $3034065ERL #Fuse 1 (#21)
              $3034065ERL #Fuse 2 (#22)
              $20050000RL #Unused- music placeholder (#23)
              $20050000RL #Unused- music placeholder (#24)

#Level entrance text pointers
%patch $31B18 $201F0000RL #Map
              $20220000RL #Level 1
              $20250000RL #Level 2
              $20280000RL #Level 3...
              $202B0000RL #4
              $202E0000RL #5
              $20310000RL #6
              $20340000RL #7
              $20370000RL #8
              $30340000RL #9
              $203D0000RL #10
              $20400000RL #11
              $20440000RL #12
              $20470000RL #13
              $30340000RL #14
              $204D0000RL #15
              $204A0000RL  #Defense Tunnel 1 (#16)
              $204A0000RL  #Defense Tunnel 2 (#17)
              $204A0000RL  #Defense Tunnel 3 (#18)
              $204A0000RL  #Defense Tunnel 4 (#19)
              $20400000RL  #Dynamo Corridor (#20)
              $30340000RL  #Fuse 1 (#21) (#21)
              $30340000RL  #Fuse 2 (#22)
              $20220000RL  #Unused- music placeholder (#23)
              $20220000RL  #Unused- music placeholder (#24)

#Warp cheat can access all levels
%patch $7799 $17

#Text
%patch $30864 " Warp to which level(1-22):" $00


# Make flags and level completion blocks work for 32 levels
%patch $60B3 $19

#World Map
%patch $20040 "Ultramatic" $00
%patch $201F0 "Keen disarms the" $0A "Ultra Omegamatic" $00
%patch $30605 "Exit to Ultramatic" $00

#Level 1
%patch $20050 "Initial Corridor" $00
%patch $20220 "Keen travels through " $0A "Initial Corridor" $00

#Level 2
%patch $20070 "Gallery A1" $00
%patch $20250 "Keen runs in " $0A "Gallery A1" $00

#Level 3
%patch $20080 "Gallery A2" $00
%patch $20280 "Keen runs in " $0A "Gallery A2" $00

#Level 4
%patch $200A0 "Fuse A1" $00
%patch $202B0 "Keen attacks the" $0A "Fuse Center A1" $00

#Level 5
%patch $200C0 "Gallery A3" $00
%patch $202E0 "Keen runs in the" $0A "Gallery A3" $00

#Level 6
%patch $200E0 "Fuse Center A2" $00
%patch $20310 "Keen attacks the" $0A "Fuse Center A2" $00

#Level 7
%patch $20100 "Gallery A4" $00
%patch $20340 "Keen runs in the" $0A "Gallery A4" $00

#Level 8
%patch $20120 "Fuse Center A3" $00
%patch $20370 "Keen attacks the" $0A "Fuse Center A3" $00

#Level 9
%patch $3099E "Fuse Quantum" $00
%patch $30340 "Keen attacks a" $0A "Fuse Quantum" $00

#Level 10
%patch $20160 "Fuse Center A4" $00
%patch $203D0 "Keen attacks the" $0A "Fuse Center A4" $00

#Level 11
%patch $20180 "Dynamo Center" $00
%patch $20400 "Keen shoots in a" $0A "Dynamo Center" $00

#Level 12
%patch $201A0 "Shikadi Quantum Dynamo" $00
%patch $20440 "Keen disarms the" $0A "Shikadi Quantum Dynamo" $00

#Level 13
%patch $201C0 "Greenland Base" $00
%patch $20470 "Keen disables" $0A "Greenland Base" $00

#Level 14
%patch $3099E "Fuse Quantum" $00
%patch $30340 "Keen attacks a" $0A "Fuse Quantum" $00

#Level 15
%patch $201E0 "High Scores"
%patch $204D0 "Keen wins the game" $0A "through the" $0A "High Scores" $00

#Levels 16-19
%patch $201D0 "Protection Gallery" $00
%patch $204A0 "Keen travels in a" $0A "Protection Gallery" $00

#Levels 21-22
%patch $3099E "Fuse Quantum" $00
%patch $30340 "Keen attacks a" $0A "Fuse Quantum" $00

#Level 20
%patch $20180 "Dynamo Center" $00
%patch $20400 "Keen shoots in a" $0A "Dynamo Center" $00

# Used when Keen enters Korath
%patch $30563 "Keen explores" $0A
              "Greenland" $00

#What Keen says when he breaks the secret fuse
%patch $31BFB "Now the generator" $0A
	       "is disabled" $0A $00

#What Keen says when he breaks a fuse
%patch $31C20 "Now Disabled!" $00


#Main menu actions list
%patch $3CB3 $0442W #3C12: Terminator sequence and title screen
%patch $3CB5 $0459W #3C29: Demo 1
%patch $3CB7 $0466W #3C36: Star wars story
%patch $3CB9 $046DW #3C3D: Demo 2
%patch $3CBB $047BW #3C4B: High score demo
%patch $3CBD $0482W #3C52: Demo 3
%patch $3CBF $0490W #3C60: Demo 4
              
              
#################
#Shikadi                     #
#################

#Polesparks check horizontally, not vertically for Keen:
%patch $130F5 $0A
%patch $130FC $0A

#Shikadi's strength
%patch $12EFA $0008W

#Polesparks move horizontally. They also animate and (mostly) move toward Keen
#SIDE EFFECT: Polesparks don't always go in Keen's direction
%patch $130F5 $0A		#Zap 1 checks horizontally for Keen, not vertically
%patch $130FC $0A		#Zap 2 checks horizontally for Keen, not vertically

%patch $13105 $0E		#Zap 1 (mostly) heads horizontally for Keen, not vertically
%patch $13110 $0E		#Zap 2 (mostly) heads horizontally for Keen, not vertically

%patch $331A4 $0003W		#Zap frame 1 animates
%patch $331C2 $0003W		#Zap frame 2 animates

%patch $331AA $00000000L	#Zap frame 1 ignores vertical speed stuff
%patch $331C8 $00000000L	#Zap frame 2 ignores vertical speed stuff

%patch $331A6 $0040W		#Zap frame 1 speed
%patch $331C4 $0040W		#Zap frame 2 speed



#################
#Shocksund              #
#################

#Shocksund strength
%patch $1328A $0005W

#################
#Slicestar                  #
#################

#Slicestar strength
%patch $11762 $0001W #Horizontal
%patch $11806 $0001W #Diagonal


#################
#Koarth                     #
#################

#Korath has a strength of 3 (Now always spawns moving right.)
%patch $138F1 $C7 $47 $40 $0003W  $C7 $47 $0E $0001W  $B8 $30D2W
              $50 $FF $36 $40 $9E $9A $090B11C4RL     $83 $C4 $04 $5D $CB

#Use new collision when walking, sitting
%patch $33426 $06B90E68RL
%patch $33444 $06B90E68RL
%patch $33462 $06B90E68RL
%patch $33480 $06B90E68RL
%patch $3349E $06B90E68RL

#New collision for Korath
%patch $79F6 $EB $5C
%patch $79F8 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $05
             $9A $0AAF1517RL     $83 $3D $03 $75 $34 $FF $4C $40 $75 $1C $C7
             $44 $16 $0000W  $C7 $44 $18 $0000W  $B8 $3168W  $50 $57 $56 $9A
             $090B16CDRL     $83 $C4 $06 $5F $5E $5D $CB $C7 $44 $42 $0002W
             $C7 $44 $04 $0001W  $57 $9A $0CCB10B3RL     $83 $C4 $02 $5F $5E
             $5D $CB

#Korath are deadly, shootable
%patch $13956 $55 $8B $EC $56 $8B $76 $08 $83 $3C $02 $75 $08 $9A $0AAF1517RL #Check for Keen, if yes, kill
                      $5E $5D $CB $83 $3C $03 $75 $10 $B8 $3168W  $50 $56 $FF #Check for Keen shot, if yes, stun
                  $76 $06 $9A $090B16CDRL     $83 $C4 $06 $5E $5D $CB

#################
#Q.E.D                       #
#################

#QED Stuff
#Spirogrip always produces QED
%patch $F4E4 $0280W $0280W $0280W

#Spirogrip spawn produces QED, caches Spirogrip, anim
%patch $EFD0 $57 $56 $9A $06B90B00RL     $83 $C4 $04
             $C7 $06 $C2A5W  $0001W  $C7 $06 $C291W  $0001W  $E9 $03BEW

#Disable Add VBLs (Free $7690-$7715)
%patch $768D $E9 $0086W

#New QED spawn, foreground, set health =$06B90B00RL
%patch $7690 $55 $8B $EC $33 $C0 $50 $9A $06B91DCDRL     $83 $C4 $02 $8B $1E
             $40 $9E $C7 $07 $000DW  $C7 $47 $02 $0001W  $C7 $47 $20 $0003W
             $C7 $47 $06 $0000W  $83 $3E $6F34W  $01 $73 $06 $C7 $06 $6F34W  $0018W  $8B $46 $06 $B1 $08
             $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05 $FF00W  $89 $47 $0C
             $C7 $47 $0E $0001W  $C7 $47 $10 $0001W  $B8 $2824W  $50 $53 $9A
             $090B11C4RL     $83 $C4 $04 $C7 $06 $6F5CW  $0000W  $5D $CB

#When Keen dies reset fuse
%patch $C048 $06 $B8 $0BB2W  $50 $EB $04 $B8 $0BD0W  $50 $FF $36 $3E $9E
             $9A $090B1242RL     $83 $C4 $04 $C7 $06 $6F34W  $0000W  $C7
             $06 $6F5CW  $0000W

#New collision: Respond to Keen's shots =$11C40B61RL
%patch $127A1 $55 $8B $EC $56 $8B $76 $08 $83 $3C $03 $75 $F1 $C7 $04 $0001W #Custom smash shot
              $C7 $44 $1C $2842W  $FF $0E $6F34W  $FF $0E $6F5CW  $83 $3E $6F5CW
                  $00 $75 $06 $C7 $06 $6F5CW  $0003W  $B8 $0005W  $50 $9A
              $196E09EFRL     $83 $C4 $02 $5E $5D $CB

#QED behavior: Set sprite depending on health
%patch $127EA $55 $8B $EC $56 $8B $76 $06 $83 $3E $6F34W  $17 $75 $05
              $C7 $44 $1E $018DW   $83 $3E $6F34W  $14 $75 $05
              $C7 $44 $1E $018EW   $83 $3E $6F34W  $11 $75 $05
              $C7 $44 $1E $018FW   $83 $3E $6F34W  $0E $75 $05
              $C7 $44 $1E $0190W   $83 $3E $6F34W  $0B $75 $05
              $C7 $44 $1E $0191W   $83 $3E $6F34W  $08 $75 $05
              $C7 $44 $1E $0192W   $83 $3E $6F34W  $05 $75 $05
              $C7 $44 $1E $0193W   $83 $3E $6F34W  $02 $75 $05
              $C7 $44 $1E $0194W   $5E $5D $CB

#QED initial state- uses special-shot collision
%patch $334C6 $0000W $0000W $0000W $0000W $0001W $0008W $0000W $0000W
              $11C40BAARL   $11C40B61RL   $090B17B5RL   $3186W

#Custom shot smash actions, use Spirogrip =$2824W
%patch $32B64 $0189W $0189W $0000W $0000W $0000W $000CW $0000W $0000W 
              $00000000L    $00000000L    $090B17B5RL   $2842W
%patch $32B82 $018AW $018AW $0000W $0000W $0000W $000CW $0000W $0000W 
              $00000000L    $00000000L    $090B17B5RL   $2860W
%patch $32BA0 $018BW $018BW $0000W $0000W $0000W $000CW $0000W $0000W 
              $00000000L    $00000000L    $090B17B5RL   $287EW
%patch $32BBE $018CW $018CW $0000W $0000W $0000W $000CW $0000W $0000W #Here
              $00000000L    $11C40456RL   $090B17B5RL   $0000W

#Remove fragment collision from Mine fragment
%patch $32A6A $11C40D61RL

#Shot collision: when health depleted smash fuse =$11C40456RL
%patch $12096 $55 $8B $EC $56 $8B $76 $08 $83 $3E $6F34W  $01 $73 $EF $FF $74 $2E
              $FF $74 $2C $9A $0F920628RL     $83 $C4 $04 $FF $74 $2E $FF $74
              $30 $9A $0F920628RL     $83 $C4 $04 $FF $74 $32 $FF $74 $2C $9A
              $0F920628RL     $83 $C4 $04 $FF $74 $32 $FF $74 $30 $9A $0F920628RL
              $83 $C4 $04 $B8 $0002W  $50 $B8 $0004W  $50 $B8 $0002W 
              $50 $B8 $0041W  $50 $33 $C0 $50 $50 $9A $174E0D75RL     $83 $C4
              $0C $B8 $0002W  $50 $B8 $0004W  $50 $B8 $0004W  $50 $B8 $0041W 
              $50 $33 $C0 $50 $B8 $0004W  $50 $9A $174E0D75RL     $83 $C4 $0C
              $9A $0F920677RL     $56 $9A $06B91E47RL     $83 $C4 $02 $C7 $06 #Penalty for savegame scumming
              $6F34W $0003W   $5E $5D $CB

################
#Volteface                #
################

#Initial Volte-face direction: Right 
%patch $10B93 $C7 $47 $0E $0001W 
%patch $10B10 $0001W 

#New Volte-face actions, act like a horizontal platform 
%patch $3200C $01A1W $01A3W $0003W $0000W $0000W $0006W $0000W $0000W 
              $0F92127ERL   $0F92149DRL   $090B17B5RL   $1CEAW 
%patch $3202A $01A2W $01A4W $0003W $0000W $0000W $0006W $0000W $0000W 
              $0F92127ERL   $0F92149DRL   $090B17B5RL   $1CCCW 

#Stunned Volte-face stuns permanently 
%patch $32084 $01A5W $01A5W $0002W $0000W $0000W $0000W $0000W $0000W 
              $090B1710RL   $00000000L    $090B195ARL   $0000W 

#Custom Volte-Face speed 
%patch $10B9E $55 $8B $EC $83 $EC $04 $56 $57 $8B $7E $06 $83 $3E $85 $BF $00 
              $75 $1F $83 $3E $83 $BF $00 $75 $18 $8B $45 $0E $BA $0020W  $F7 
              $EA $F7 $2E $B4 $9B $A3 $85 $BF $8B $45 $10 $BA $0020W  $E9 
          $F721W  $5F $5E $8B $E5 $5D $CB

###########################
# K1n9_Duk3 fix:
# --------------
# Make sure Volte's stunned stars don't cause RF_PlaceSprite errors after loading a saved game
%patch $10DD6 
	$B8 $1D44w	#	mov	ax, offset s_voltestunned
	$50		#	push	ax
	$56		#	push	si
	$FF $76 $06	#	push	bp+arg_0
	$9A $090B16CDrl	#	call	StunContact
	$83 $C4 $06	#	add	sp, 6
	$5E		#	pop	si
	$5D		#	pop	bp
	$CB		#	retf
###########################

%end
